VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cOrbImpl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (c) 1999 Martin.Both

'This library is free software; you can redistribute it and/or
'modify it under the terms of the GNU Library General Public
'License as published by the Free Software Foundation; either
'version 2 of the License, or (at your option) any later version.

'This library is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
'Library General Public License for more details.

Option Explicit

Private iOrbState As Integer
Const ORBST_NOTEXISTS As Integer = 0
Const ORBST_ISINIT As Integer = 1
Const ORBST_ISACTIVE As Integer = 2
Const ORBST_SHUTDOWN As Integer = 3
Const ORBST_ISDOWN As Integer = 4
Private bThreadUsed As Boolean
Private lTimeOutHost As Long
Private lTimeOutServ As Long

Private Type tHostConn 'cOrbStream
    sHostPort As String
    iGetCnt As Integer
    oSock As cOrbSocket
    lTime As Long
End Type
Private conCnt As Long
'oHostConns(0...UBound) are connections to other ORBs if oSock is not nothing
Private oHostConns() As tHostConn
Private lReqId As Long

'Structure used in select() call
'struct timeval {
'    long    tv_sec;         /* seconds */
'    long    tv_usec;        /* and microseconds */
'};
Private Type tTimeVal
    tv_sec As Long
    tv_usec As Long
End Type

'int PASCAL FAR select (int nfds, fd_set FAR *readfds, fd_set FAR *writefds,
'   fd_set FAR *exceptfds, const struct timeval FAR *timeout);
Private Declare Function dllSelect Lib "Ws2_32.dll" Alias "select" _
    (ByVal nfds As Long, ByRef readFDs As Any, ByRef writeFDs As Any, _
    ByRef exceptFDs As Any, ByRef timeOut As tTimeVal) As Long

Private sLogFile As String
Private Type tServConn
    oSock As cOrbSocket
    lTime As Long
End Type
'TimeOut check counter
Private iTOCnt As Integer
'oServConns(0) is the listen point of this ORB
'oServConns(1...UBound) are connections to this ORB if oSock is not nothing
Private oServConns() As tServConn
Private lSelFDs() As Long
Private sImplHost As String
Private sImplPort As String
Private collImpls As New Collection

#If SERVICERESOLVER Then
Private oServiceResolver As New c_IOPInitialReferencesImpl
#End If

'GetTickCount();
Private Declare Function GetTickCount Lib "kernel32" () As Long

'GetSystemTime();
Private Declare Sub GetSystemTime Lib "kernel32" _
    (lpSystemTime As SYSTEMTIME)
Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Sub Class_Initialize()
    ReDim oHostConns(0 To 2) As tHostConn
    conCnt = 0
    lReqId = 0
    ReDim oServConns(0 To 0) As tServConn
    ReDim lSelFDs(0 To 5) As Long
End Sub

Public Function getNextReqId() As Long
    lReqId = lReqId + 1
    getNextReqId = lReqId
End Function

Public Function string_to_object(ByVal oEx As cOrbException, sURL As String) _
    As cOrbObjRef
    'Assert that init was successfully called
    If oServConns(0).oSock Is Nothing Then
        Dim oSystemEx As New cOrbSystemException
        Call oSystemEx.setINITIALIZE(1, oSystemEx.CompletedNO)
        Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
        GoTo ExHandler
    End If
    If InStr(sURL, "IOR:") = 1 Then
        Set string_to_object = iorURL(oEx, sURL)
    ElseIf InStr(sURL, "file://") = 1 Then
        Set string_to_object = file_to_object(oEx, sURL)
    ElseIf InStr(sURL, "http://") = 1 Then
        Set string_to_object = http_to_object(oEx, sURL)
    ElseIf InStr(sURL, "iioploc://") = 1 Then
        Set string_to_object = New cOrbObjRef
        Call string_to_object.readIIOPAddr(oEx, Me, Mid$(sURL, 11))
    ElseIf InStr(sURL, "corbaloc:") = 1 Then
        Set string_to_object = corbalocURL(oEx, Mid$(sURL, 10))
    ElseIf InStr(sURL, "corbaname:") = 1 Then
        Set string_to_object = corbanameURL(oEx, Mid$(sURL, 11))
    Else
        Call oEx.setMe("Invalid URL: " & sURL)
    End If
    If oEx.isSet Then
        GoTo ExHandler
    End If
    Exit Function
ExHandler:
    Call oEx.addPrefix("string_to_object: ")
    Set string_to_object = Nothing
End Function

'sIOR contains "file://"
Private Function file_to_object(ByVal oEx As cOrbException, ByVal sURL As String) _
    As cOrbObjRef
On Error GoTo ErrHandler
    Dim sFileName As String
    Dim iFileNo As Integer
    Dim sLine As String
   
    sFileName = Mid$(sURL, 8)
    iFileNo = FreeFile
    Open sFileName For Input As #iFileNo
    If Not EOF(iFileNo) Then
        Line Input #iFileNo, sLine
    End If
    Close #iFileNo
    
    Dim pos As Long
    pos = InStr(sLine, "IOR:")
    If pos = 0 Then
        Call oEx.setMe("File doesn't contain an IOR. " & sURL)
        GoTo ExHandler
    End If
    Set file_to_object = iorURL(oEx, Mid$(sLine, pos))
    If oEx.isSet Then
        GoTo ExHandler
    End If
    Exit Function
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    Call oEx.addPrefix("file_to_object: ")
    Set file_to_object = Nothing
End Function

'sIOR contains "http://"
Private Function http_to_object(ByVal oEx As cOrbException, ByVal sURL As String) _
    As cOrbObjRef
On Error GoTo ErrHandler
    Dim pos As Long
    Dim sHostPort As String
    Dim sPath As String
    
    pos = InStr(8, sURL & "/", "/")
    sHostPort = Mid$(sURL, 8, pos - 8)
    sPath = Mid$(sURL, pos)
    
    Dim oSock As New cOrbSocket
    Call oSock.initConnect(oEx, sHostPort, "80")
    If oEx.isSet Then
        GoTo ExHandler
    End If
    Call oSock.sendString(oEx, "GET " & sPath & " HTTP/1.0" & vbCrLf & vbCrLf _
        & "User-Agent: VB-IIOP VisualBasic 24-08-1999" & vbCrLf & vbCrLf _
        & "Accept: text/html, image/gif, image/jpeg, *; q=.2, */*; q=.2" & vbCrLf & vbCrLf _
        & "Connection: keep -alive" & vbCrLf & vbCrLf & vbCrLf & vbCrLf)
    If oEx.isSet Then
        GoTo ExHandler
    End If
    
    Dim webpage As String
    webpage = oSock.recvString(oEx)
    If oEx.isSet Then
        GoTo ExHandler
    End If
    Call oSock.termConnect(oEx)
    If oEx.isSet Then
        GoTo ExHandler
    End If
    
    pos = InStr(webpage, "IOR:")
    If pos = 0 Then
        Call oEx.setMe("Webpage doesn't contain an IOR. " & sURL)
        GoTo ExHandler
    End If
    Set http_to_object = iorURL(oEx, Mid$(webpage, pos))
    If oEx.isSet Then
        GoTo ExHandler
    End If
    Exit Function
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    Call oEx.addPrefix("http_to_object: ")
    Set http_to_object = Nothing
End Function

'sIOR contains "IOR:..."
Private Function iorURL(ByVal oEx As cOrbException, ByRef sIOR As String) _
    As cOrbObjRef
    
    Dim oIn As New cOrbStream
    Call oIn.initBuffer((Len(sIOR) - 3) \ 2, Me)
    Call oIn.recvFromIOR(sIOR)
    Call oIn.readEncapOpen(oEx, (Len(sIOR) - 3) \ 2)
    If oEx.isSet Then GoTo ExHandler
    Set iorURL = oIn.read_ObjRef(oEx)
    If oEx.isSet Then GoTo ExHandler
    Call oIn.readEncapClose(oEx)
    If oEx.isSet Then GoTo ExHandler
    Exit Function
ExHandler:
    Call oEx.addPrefix("iorURL: ")
    Set iorURL = Nothing
End Function

Public Function object_to_string(ByVal oEx As cOrbException, _
    ByVal oObjRef As cOrbObjRef) As String
    
    Dim oOut As New cOrbStream
    
    'GIOP Message Header
    Call oOut.initBuffer(1024, Me)
    
    'Like oOut.writeEncapOpen() without len
    Call oOut.write_boolean(oEx, oOut.littleEndian)
    If oEx.isSet Then GoTo ExHandler
    Call oOut.write_ObjRef(oEx, oObjRef)
    If oEx.isSet Then GoTo ExHandler
    
    Call oOut.sendToIOR(oEx, object_to_string)
    If oEx.isSet Then GoTo ExHandler
    Exit Function
ExHandler:
    Call oEx.addPrefix("object_to_string: ")
End Function

Private Function iioplocAddrList(ByVal oEx As cOrbException, _
    ByRef sURL As String, ByRef sObjKey As String, ByRef sStringName As String)
    Dim startPos As Long
    Dim nextPos As Long
    Dim isIIOP As Boolean
    Dim IIOPCnt As Long
    startPos = 1
    Do
        nextPos = InStr(startPos, sURL, ",")
        If nextPos = 0 Then
            Exit Do
        End If
        nextPos = nextPos + 1
        If InStr(startPos, sURL, "//") = startPos Then
            startPos = startPos + 2
            isIIOP = True
        ElseIf InStr(startPos, sURL, ":") = startPos Then
            startPos = startPos + 1
            isIIOP = True
        ElseIf InStr(startPos, sURL, "iiop:") = startPos Then
            startPos = startPos + 5
            isIIOP = True
        End If
        If isIIOP Then
            isIIOP = False
            IIOPCnt = IIOPCnt + 1
            iioplocAddrList = iioplocAddrList _
                & Mid$(sURL, startPos, nextPos - startPos)
        End If
        startPos = nextPos
    Loop
    If InStr(startPos, sURL, "//") = startPos Then
        startPos = startPos + 2
        isIIOP = True
    ElseIf InStr(startPos, sURL, ":") = startPos Then
        startPos = startPos + 1
        isIIOP = True
    ElseIf InStr(startPos, sURL, "iiop:") = startPos Then
        startPos = startPos + 5
        isIIOP = True
    End If
    nextPos = InStr(startPos, sURL, "/")
    If nextPos = 0 Then
        nextPos = InStr(startPos, sURL, "#")
        If nextPos = 0 Then
            nextPos = Len(sURL) + 1
        End If
    End If
    If isIIOP Then
        isIIOP = False
        IIOPCnt = IIOPCnt + 1
        iioplocAddrList = iioplocAddrList _
            & Mid$(sURL, startPos, nextPos - startPos)
    End If
    nextPos = InStr(startPos, sURL, "#")
    If nextPos <> 0 Then
        sStringName = Mid$(sURL, nextPos + 1, Len(sURL) - nextPos)
    Else
        nextPos = Len(sURL) + 1
    End If
    startPos = InStr(startPos, sURL, "/")
    If startPos <> 0 And startPos < nextPos Then
        startPos = startPos + 1
        sObjKey = Mid$(sURL, startPos, nextPos - startPos)
    End If
    If IIOPCnt = 0 Then
        Call oEx.setMe("Missing an IIOP address: " & sURL)
        GoTo ExHandler
    End If
    Exit Function
ExHandler:
End Function

Private Function corbalocURL(ByVal oEx As cOrbException, _
    ByRef sURL As String) As cOrbObjRef
    
    Dim sAddrList As String
    Dim sObjKey As String
    Dim sStringName As String
    sAddrList = iioplocAddrList(oEx, sURL, sObjKey, sStringName)
    If oEx.isSet Then GoTo ExHandler
    
    If Len(sStringName) <> 0 Then
        Call oEx.setMe("Inadequate # character: " & sURL)
        GoTo ExHandler
    End If
    
    Set corbalocURL = New cOrbObjRef
    Call corbalocURL.readIIOPAddr(oEx, Me, sAddrList & "/" & sObjKey)
    If oEx.isSet Then GoTo ExHandler
    Exit Function
ExHandler:
    Call oEx.addPrefix("corbalocURL: ")
    Set corbalocURL = Nothing
End Function

Private Function corbanameURL(ByVal oEx As cOrbException, ByRef sURL As String) _
    As cOrbObjRef
    
    Dim sAddrList As String
    Dim sObjKey As String
    Dim sStringName As String
    sAddrList = iioplocAddrList(oEx, sURL, sObjKey, sStringName)
    If oEx.isSet Then GoTo ExHandler
    If Len(sObjKey) = 0 Then
        sObjKey = "NameService"
    End If
    'Get the naming context object reference
    Set corbanameURL = New cOrbObjRef
    Call corbanameURL.readIIOPAddr(oEx, Me, sAddrList & "/" & sObjKey)
    If oEx.isSet Then GoTo ExHandler
    Call corbanameURL.narrow(oEx, "???NamingContext???")
    If oEx.isSet Then GoTo ExHandler
    '??? objref should be a reference to a NamingContext
    'Convert sStringName to a CosNaming::Name
    'Pass CosNaming::Name to a resolve operation on the naming context
    'Or use resolve_str of CosNamingExt
        Dim oSystemEx As New cOrbSystemException
        Call oSystemEx.setNOIMPLEMENT(1, oSystemEx.CompletedNO)
        Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
        GoTo ExHandler
    'corbanameURL= resolve(sStringName)
    Exit Function
ExHandler:
    Call oEx.addPrefix("corbanameURL: ")
    Set corbanameURL = Nothing
End Function

Public Function getSocket(ByVal oEx As cOrbException, _
    ByRef sHostPort As String, ByVal bNew As Boolean) As cOrbSocket
    
    Dim lTime As Long
    lTime = GetTickCount() 'or getTime()
    Dim i1 As Long
    For i1 = 0 To conCnt - 1
        If oHostConns(i1).sHostPort = sHostPort Then
            If oHostConns(i1).iGetCnt = 0 _
                Or getLongDiff(oHostConns(i1).lTime, lTime) > 20000& _
                Or oHostConns(i1).oSock Is Nothing Then
                Set oHostConns(i1).oSock = New cOrbSocket
                Call oHostConns(i1).oSock.initConnect(oEx, sHostPort, "900")
                If oEx.isSet Then
                    Set oHostConns(i1).oSock = Nothing
                    GoTo ExHandler
                End If
            End If
            oHostConns(i1).lTime = lTime
            If bNew Then
                oHostConns(i1).iGetCnt = oHostConns(i1).iGetCnt + 1
            End If
            Set getSocket = oHostConns(i1).oSock
            Exit Function
        End If
    Next i1
    If conCnt > UBound(oHostConns) Then
        ReDim Preserve oHostConns(0 To conCnt + 2) As tHostConn
    End If
    oHostConns(conCnt).sHostPort = sHostPort
    Set oHostConns(conCnt).oSock = New cOrbSocket
    Call oHostConns(conCnt).oSock.initConnect(oEx, sHostPort, "900")
    If oEx.isSet Then
        Set oHostConns(conCnt).oSock = Nothing
        GoTo ExHandler
    End If
    oHostConns(conCnt).lTime = lTime
    If bNew Then
        oHostConns(conCnt).iGetCnt = oHostConns(conCnt).iGetCnt + 1
    End If
    Set getSocket = oHostConns(conCnt).oSock
    conCnt = conCnt + 1
    Exit Function
ExHandler:
    Call oEx.addPrefix("getSocket: ")
    'Set getSocket = Nothing
End Function

Public Sub ungetSocket(ByRef sHostPort As String, ByVal connErr As Boolean)
    Dim i1 As Long
    For i1 = 0 To conCnt - 1
        If oHostConns(i1).sHostPort = sHostPort Then
            oHostConns(i1).iGetCnt = oHostConns(i1).iGetCnt - 1
            If oHostConns(i1).iGetCnt = 0 Or connErr Then
                Set oHostConns(i1).oSock = Nothing
            End If
            Exit For
        End If
    Next i1
End Sub

Private Function getLongDiff(ByVal l1 As Long, ByVal l2 As Long) As Long
    getLongDiff = IIf(l1 > l2, l1 - l2, l2 - l1)
End Function

Private Function getTime() As Long
    Dim lpSystemTime As SYSTEMTIME
    Call GetSystemTime(lpSystemTime) 'is about 50 times faster than "Now"
    getTime = lpSystemTime.wMonth * 31 + lpSystemTime.wDay
    getTime = getTime * 24 + lpSystemTime.wHour
    getTime = getTime * 60 + lpSystemTime.wMinute
    getTime = getTime * 60 + lpSystemTime.wSecond
End Function

Public Property Get localHost() As String
    localHost = sImplHost
End Property

'4.6, ORB Initialization
'The ORB_init is part of the CORBA module but not part of the ORB interface.
'We still don't use a CORBA module so init() is part of the ORB interface.
Public Sub init(ByVal oEx As cOrbException, _
    Optional ByVal OAPort As String = "0", _
    Optional ByVal sInitRefURL As String = "corbaloc://localhost:900", _
    Optional ByVal LogFile As String = "")

    lTimeOutHost = 40000
    lTimeOutServ = 60000
    sLogFile = LogFile
    'Get real name of localhost
    Set oServConns(0).oSock = New cOrbSocket
    sImplHost = oServConns(0).oSock.getHostName(oEx, True)
    If oEx.isSet Then
        GoTo ExHandler
    End If
    'Bind the server socket immediately to retrieve the actual port
    Call oServConns(0).oSock.initBind(oEx, OAPort)
    If oEx.isSet Then
        If oEx.Number = 10048 Then 'WSAEADDRINUSE
            'Maybe WSA was not terminated last time
            Call oServConns(0).oSock.initTermAll(True)
        End If
        GoTo ExHandler
    End If
    sImplPort = oServConns(0).oSock.socketPort
    
#If SERVICERESOLVER Then
    'Initialize the initial references resolver, by Craig Neuwirt
    Call oServiceResolver.Initialize(oEx, Me, sInitRefURL)
    If oEx.isSet Then GoTo ExHandler
#End If
    iOrbState = ORBST_ISINIT
    Exit Sub
ExHandler:
    Set oServConns(0).oSock = Nothing
    Call oEx.addPrefix("initOrb: ")
End Sub

Public Sub exceptionLog(ByVal oEx As cOrbException)
    Call messageLog("Exception: " & oEx.Number & ", " & oEx.Description)
    Call oEx.unSet
End Sub

Public Sub messageLog(ByVal sMessage As String)
    If Len(sLogFile) = 0 Then
        Exit Sub
    End If
    Dim iFileNo As Integer
    iFileNo = FreeFile
    Open sLogFile For Append As #iFileNo
    Dim lpSystemTime As SYSTEMTIME
    Call GetSystemTime(lpSystemTime) 'is about 50 times faster than "Now"
    Print #iFileNo, lpSystemTime.wYear & "-" & msg02(lpSystemTime.wMonth) & "-" _
        & msg02(lpSystemTime.wDay) & " " & msg02(lpSystemTime.wHour) & ":" _
        & msg02(lpSystemTime.wMinute) & ":" & msg02(lpSystemTime.wSecond) & " " _
        & sMessage
    Close #iFileNo
End Sub

Private Function msg02(ByVal iVal As Integer) As String
    msg02 = iVal
    If iVal < 10 Then msg02 = "0" & msg02
End Function

'4.7, Obtaining Initial Object References
'Written by Craig Neuwirt
#If SERVICERESOLVER Then
Public Function list_initial_services(ByVal oEx As cOrbException _
    ) As c_SeqString
    Set list_initial_services = oServiceResolver.List(oEx)
End Function
#End If

'4.7, Obtaining Initial Object References
'Written by Craig Neuwirt
#If SERVICERESOLVER Then
Public Function resolve_initial_references(ByVal oEx As cOrbException, _
    ByVal id As String) As cOrbObjRef
    Set resolve_initial_references = oServiceResolver.f_get(oEx, id)
End Function
#End If

Public Sub connect(ByVal oEx As cOrbException, ByVal newImpl As cOrbSkeleton, _
    Optional ByVal sKey As String = "")
    On Error GoTo ErrHandler
    If iOrbState = ORBST_NOTEXISTS Then
        Dim oSystemEx As New cOrbSystemException
        Call oSystemEx.setOBJECTNOTEXIST(1, oSystemEx.CompletedNO)
        Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
        GoTo ExHandler
    End If
    If sKey = "" Then
        sKey = collImpls.Count & "_" & GetTickCount()
    End If
    Dim oObjRef As New cOrbObjRef
    '"1.1@host:portno/key"
    Call oObjRef.readIIOPAddr(oEx, Me, "1.1@" & sImplHost & ":" & _
        sImplPort & "/" & sKey, sImplPort, newImpl.TypeId(0))
    If oEx.isSet Then
        GoTo ExHandler
    End If
    Set newImpl.ObjRef = oObjRef
    Call collImpls.Add(newImpl, sKey)
    Exit Sub
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    Call oEx.addPrefix("connectToOrb: ")
End Sub

Public Sub disconnect(ByVal oEx As cOrbException, ByVal oldImpl As cOrbSkeleton)
    On Error GoTo ErrHandler
    Dim oObjRef As cOrbObjRef
    Dim sKey As String
    Dim oImpl As cOrbSkeleton
    Dim oSystemEx As cOrbSystemException
    Set oObjRef = oldImpl.ObjRef
    If oObjRef Is Nothing Then
        GoTo ExINVOBJREF
    End If
    sKey = oObjRef.objectKey
    On Error GoTo SearchErr
    Set oImpl = collImpls.item(sKey)
SearchResume:
    On Error GoTo ErrHandler
    If oImpl Is Nothing Then
        GoTo ExINVOBJREF
    End If
    Call collImpls.Remove(sKey)
    Call oObjRef.releaseMe
    Set oldImpl.ObjRef = Nothing
    Exit Sub
SearchErr:
    Set oImpl = Nothing
    GoTo SearchResume
ExINVOBJREF:
    Set oSystemEx = New cOrbSystemException
    Call oSystemEx.setINVOBJREF(1, oSystemEx.CompletedNO)
    Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
    GoTo ExHandler
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    Call oEx.addPrefix("disconnect: ")
End Sub

'4.12.3, Run. After ORB Initialization an application should call either
'run or perform_work on its main thread. Run will block until the ORB has
'completed the shutdown process, initiated when some thread calls shutdown.
Public Sub run(ByVal oEx As cOrbException)
On Error GoTo ErrHandler
    Do While iOrbState <> ORBST_ISDOWN
        Call perform_work(oEx, 10)
        If oEx.isSet Then GoTo ExHandler
        DoEvents 'Prevent blocking other window processes
    Loop
    Exit Sub
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    Call oEx.addPrefix("run: ")
End Sub

'4.12.1, Indicates that the ORB needs the main thread to perform some work
Public Function work_pending(ByVal oEx As cOrbException) As Boolean
    Dim oSystemEx As cOrbSystemException
    If iOrbState = ORBST_NOTEXISTS Then
        Set oSystemEx = New cOrbSystemException
        Call oSystemEx.setOBJECTNOTEXIST(1, oSystemEx.CompletedNO)
        Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
        GoTo ExHandler
    ElseIf iOrbState = ORBST_ISDOWN Then
        Set oSystemEx = New cOrbSystemException
        Call oSystemEx.setBADINVORDER(4, oSystemEx.CompletedNO)
        Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
        GoTo ExHandler
    End If
    work_pending = True
    Exit Function
ExHandler:
    Call oEx.addPrefix("work_pending: ")
End Function

'4.12.2, Called by run() with lWaitTime > 0 or called by a Timer if work pending
Public Sub perform_work(ByVal oEx As cOrbException, _
    Optional ByVal lWaitTime As Long = 0)
On Error GoTo ErrHandler
    bThreadUsed = True
    Dim oSystemEx As cOrbSystemException
    If iOrbState = ORBST_NOTEXISTS Then
        'Assert that init was successfully called
        Set oSystemEx = New cOrbSystemException
        Call oSystemEx.setOBJECTNOTEXIST(1, oSystemEx.CompletedNO)
        Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
        GoTo ExHandler
    ElseIf iOrbState = ORBST_ISDOWN Then
        Set oSystemEx = New cOrbSystemException
        Call oSystemEx.setBADINVORDER(4, oSystemEx.CompletedNO)
        Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
        GoTo ExHandler
    ElseIf iOrbState = ORBST_ISINIT Then
        'Auto Activate if called first time
        'If Not oServConns(0).oSock.isListen Then
        Call oServConns(0).oSock.startListen(oEx)
        If oEx.isSet Then GoTo ExHandler
        Call messageLog("Server is listening on port " _
            & sImplPort & " at " & sImplHost)
        iOrbState = ORBST_ISACTIVE
    ElseIf iOrbState = ORBST_SHUTDOWN Then
        'Reduce timeout
        lTimeOutServ = 1000
        lTimeOutHost = 30000
    End If
    Dim slotLen As Long
    Dim slotCnt As Long
    Dim lFDCnt As Long
    slotLen = UBound(oServConns) + 1
    'Collect all file descriptors of all kind of used sockets
    lFDCnt = 0
    For slotCnt = 0 To UBound(oServConns)
        If Not oServConns(slotCnt).oSock Is Nothing Then
            lFDCnt = lFDCnt + 1
            lSelFDs(lFDCnt) = oServConns(slotCnt).oSock.socketFd
        End If
    Next slotCnt
    lSelFDs(0) = lFDCnt 'readFDs.fd_count
    lSelFDs(slotLen + 1) = 0 'writeFDs.fd_count
    lSelFDs(slotLen * 2 + 2) = 0 'exceptFDs.fd_count
    
    'Check file descriptors, Possible to accept/read data or timeout?
    Dim timeOut As tTimeVal
    timeOut.tv_usec = (lWaitTime Mod 1000) * 1000
    timeOut.tv_sec = lWaitTime \ 1000
    If dllSelect(slotLen, lSelFDs(0), lSelFDs(slotLen + 1), _
        lSelFDs(slotLen * 2 + 2), timeOut) = -1 Then
        Call oEx.setMe("select() failed", Err.LastDllError)
        GoTo ExHandler
    End If
    Dim lTime As Long
    lTime = GetTickCount()
    Dim lOpenCnt As Long
    Dim recvAgain As Boolean
    'Check served socket
    Dim oOut As cOrbStream
    For slotCnt = 1 To UBound(oServConns)
        If oServConns(slotCnt).oSock Is Nothing Then
            GoTo nextSocket
        End If
        lOpenCnt = lOpenCnt + 1
        'Possible to read data or timeout?
        recvAgain = False
        For lFDCnt = 1 To lSelFDs(0)
            If oServConns(slotCnt).oSock.socketFd = lSelFDs(lFDCnt) Then
                recvAgain = True
                Exit For
            End If
        Next lFDCnt
        If Not recvAgain Then
            'TimeOut, Close served socked if longer than 60s unused
            If iTOCnt = 0 Then
                If getLongDiff(oServConns(slotCnt).lTime, lTime) > lTimeOutServ Then
                    GoTo closeSocket
                End If
            End If
            GoTo nextSocket
        End If
        oServConns(slotCnt).lTime = lTime
        Dim recvLen As Long
        recvLen = oServConns(slotCnt).oSock.recvCurrentLen(oEx)
        If oEx.isSet Then
            Call exceptionLog(oEx) 'Is calling oEx.unSet()
            GoTo termSocket
        End If
        If recvLen = 0 Then
            GoTo termSocket
        End If
        Dim oIn As New cOrbStream
        Call oIn.initBuffer(1024, Me)
        Dim msgType As Byte
        'Receive GIOP Message Header
        msgType = oIn.recvGIOPFromSocket(oEx, oServConns(slotCnt).oSock)
        If oEx.isSet Then
            Call exceptionLog(oEx) 'Is calling oEx.unSet()
            GoTo termSocket
        End If
        Set oOut = New cOrbStream
        Select Case msgType
        Case 0 '= GIOP Request
            Call replyRequest(oEx, oIn, oOut)
            If Not oEx.isSet And Not oOut Is Nothing Then
                '1 = Reply
                Call oOut.sendGIOPToSocket(oEx, 1, oServConns(slotCnt).oSock)
            End If
        Case 3 '= Locate Request
            Call replyLocateRequest(oEx, oIn, oOut)
            If Not oEx.isSet And Not oOut Is Nothing Then
                '4 = LocateReply
                Call oOut.sendGIOPToSocket(oEx, 4, oServConns(slotCnt).oSock)
            End If
        Case Else
            Call oEx.setMe("Unknown GIOP msgType: " & msgType)
        End Select
        If oEx.isSet Then
            Call exceptionLog(oEx) 'Is calling oEx.unSet()
            GoTo termSocket
        End If
        GoTo nextSocket
closeSocket:
        '5 = CloseConnection
        Set oOut = New cOrbStream
        'Prepare GIOP Message Header
        Call oOut.initGIOPOut(oEx, oIn.getGIOPVersion, Me)
        If oEx.isSet Then
            Call exceptionLog(oEx) 'Is calling oEx.unSet()
            GoTo termSocket
        End If
        Call oOut.sendGIOPToSocket(oEx, 5, oServConns(slotCnt).oSock)
        If oEx.isSet Then
            Call exceptionLog(oEx) 'Is calling oEx.unSet()
        End If
termSocket:
        Call oServConns(slotCnt).oSock.termAccept(oEx)
        If oEx.isSet Then
            Call exceptionLog(oEx) 'Is calling oEx.unSet()
        End If
        Set oServConns(slotCnt).oSock = Nothing
        lOpenCnt = lOpenCnt - 1
nextSocket:
    Next slotCnt
    'Check listener socket
    If Not oServConns(0).oSock Is Nothing Then
        lOpenCnt = lOpenCnt + 1
        'Acceptable connection is pending or nothing to do?
        recvAgain = False
        For lFDCnt = 1 To lSelFDs(0)
            If oServConns(0).oSock.socketFd = lSelFDs(lFDCnt) Then
                recvAgain = True
                Exit For
            End If
        Next lFDCnt
        If recvAgain Then
            'Will accept, find a free slot
            For slotCnt = 1 To UBound(oServConns)
                If oServConns(slotCnt).oSock Is Nothing Then
                    Exit For
                End If
            Next slotCnt
            If slotCnt > UBound(oServConns) Then
                ReDim Preserve oServConns(0 To slotCnt + 2) As tServConn
                ReDim lSelFDs(0 To (slotCnt + 2) * 3 + 5)
            End If
            'Accept
            Set oServConns(slotCnt).oSock = New cOrbSocket
            oServConns(slotCnt).lTime = lTime
            Call oServConns(slotCnt).oSock.initAccept(oEx, oServConns(0).oSock)
            If oEx.isSet Then GoTo ExHandler
            Call messageLog("Accepting new connection from: " & _
                oServConns(slotCnt).oSock.socketHost & ":" & _
                oServConns(slotCnt).oSock.socketPort)
        End If
    End If
    'TimeOut, Close connections to other hosts if longer than 40s unused
    If iTOCnt = 0 Then
        For slotCnt = 0 To conCnt - 1
            If Not oHostConns(slotCnt).oSock Is Nothing Then
                If (oHostConns(slotCnt).iGetCnt <= 0 And _
                    iOrbState = ORBST_SHUTDOWN) Or _
                    (oHostConns(slotCnt).iGetCnt > 0 And _
                    getLongDiff(oHostConns(slotCnt).lTime, lTime) > lTimeOutHost) _
                Then
                    Call oHostConns(slotCnt).oSock.termConnect(oEx)
                    If oEx.isSet Then
                        Call exceptionLog(oEx) 'Is calling oEx.unSet()
                    End If
                    Set oHostConns(slotCnt).oSock = Nothing
                Else
                    lOpenCnt = lOpenCnt + 1
                End If
            End If
        Next slotCnt
    End If
    'Increment timeout check counter
    iTOCnt = iTOCnt + 1
    If iTOCnt > 10 Then iTOCnt = 0
    'Do rest of shutdown
    If lOpenCnt <= 0 And iOrbState = ORBST_SHUTDOWN Then
        'Disconnect all objects
        Dim oImpl As cOrbSkeleton
        For Each oImpl In collImpls
            If Not oImpl.ObjRef Is Nothing Then
                Call oImpl.ObjRef.releaseMe
            End If
            Set oImpl.ObjRef = Nothing
        Next oImpl
        Dim lcnt As Long
        For lcnt = 1 To collImpls.Count
            Call collImpls.Remove(1)
        Next lcnt
        'No more Serviceresolver
        #If SERVICERESOLVER Then
            Call oServiceResolver.destroy
            Set oServiceResolver = Nothing
        #End If
        'Shutdown completed
        iOrbState = ORBST_ISDOWN
    End If
    bThreadUsed = False
    Exit Sub
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    bThreadUsed = False
    Call oEx.addPrefix("perform_work: ")
End Sub

'Execute a Client Request
Private Sub replyRequest(ByVal oEx As cOrbException, _
    ByVal oIn As cOrbStream, ByRef oOut As cOrbStream)
On Error GoTo ErrHandler
    'Read GIOP Request Header
    Dim i1 As Long
    Dim seqSC As Long
    Dim sOperation As String
    
    If oIn.getGIOPVersion <> "1.2" Then
        'IOP::ServiceContextList service_context;
        seqSC = oIn.read_ulong(oEx)
        If oEx.isSet Then GoTo ExHandler
        For i1 = 1 To seqSC
            Call oIn.read_ulong(oEx)
            If oEx.isSet Then GoTo ExHandler
            Call oIn.readSkip(oEx, oIn.read_ulong(oEx))
            If oEx.isSet Then GoTo ExHandler
        Next i1
    End If
    'request_id;
    Dim reqId As Long
    reqId = oIn.read_ulong(oEx)
    If oEx.isSet Then GoTo ExHandler
    'response_expected;
    Dim responseExpected As Boolean 'non oneway
    responseExpected = oIn.read_boolean(oEx)
    If oEx.isSet Then GoTo ExHandler
    
    Dim oSystemEx As cOrbSystemException 'after responseExpected
    If oIn.getGIOPVersion <> "1.0" Then
        'octet reserved[3];
        Call oIn.read_octet(oEx)
        If oEx.isSet Then GoTo ExHandler
        Call oIn.read_octet(oEx)
        If oEx.isSet Then GoTo ExHandler
        Call oIn.read_octet(oEx)
        If oEx.isSet Then GoTo ExHandler
    End If
    'sequence <octet> object_key; or TargetAddress target;
    Dim sKey As String
    Dim oImpl As cOrbSkeleton
    Set oImpl = readReqObjKey(oEx, oIn, sKey)
    If oEx.isSet Then GoTo ExHandler
    'operation;
    sOperation = oIn.read_string(oEx)
    If oEx.isSet Then GoTo ExHandler
    If oIn.getGIOPVersion <> "1.2" Then
        'Principal (not in GIOP 1.2)
        Dim pcpLen As Long
        pcpLen = oIn.read_ulong(oEx)
        If oEx.isSet Then GoTo ExHandler
        Call oIn.readSkip(oEx, pcpLen)
        If oEx.isSet Then GoTo ExHandler
    Else
        'IOP::ServiceContextList service_context;
        seqSC = oIn.read_ulong(oEx)
        If oEx.isSet Then GoTo ExHandler
        For i1 = 1 To seqSC
            Call oIn.read_ulong(oEx)
            If oEx.isSet Then GoTo ExHandler
            Call oIn.readSkip(oEx, oIn.read_ulong(oEx))
            If oEx.isSet Then GoTo ExHandler
        Next i1
    End If

    'Prepare GIOP Message Header
    'Discard oOut later if oneway
    Call oOut.initGIOPOut(oEx, oIn.getGIOPVersion, Me)
    If oEx.isSet Then
        GoTo ExHandler
    End If
    'Write GIOP Reply Header
    Dim repStatusPos As Long
    repStatusPos = writeReplyHeader(oEx, oOut, reqId, 0) '0 = NO_EXCEPTION
    If oEx.isSet Then
        GoTo ExHandler
    End If

    'Call messageLog("Request operation: " & sOperation)
    'Execute request: oImpl.sOperation()
    'Attribute accessors have operation names as follows:
    ' Attribute selector: "_get_<attribute>"
    ' Attribute mutator: "_set_<attribute>"
    'CORBA::Object pseudo-operations have operation names as follows:
    ' InterfaceDef get_interface: "_interface"
    ' get_implementation: "_implementation"
    ' : "_get_domain_managers"
    Dim repStatus As Long
    If Not oImpl Is Nothing Then
        Select Case sOperation 'Name of the CORBA operation being invoked
        Case "_is_a" 'CORBA::Object pseudo-operation
            Dim sTypeId As String
            sTypeId = oIn.read_string(oEx)
            If oEx.isSet Then GoTo ExHandler
            Dim i2 As Integer
            i2 = 0
            Do
                Select Case oImpl.TypeId(i2)
                Case sTypeId: Call oOut.write_boolean(oEx, True): Exit Do
                Case "": Call oOut.write_boolean(oEx, False): Exit Do
                Case Else: i2 = i2 + 1
                End Select
            Loop
            repStatus = 0 'NO_EXCEPTION
        Case "_non_existent" 'CORBA::Object pseudo-operation
            Call oOut.write_boolean(oEx, False)
            repStatus = 0 'NO_EXCEPTION
        Case Else
            repStatus = oImpl.execute(oEx, sOperation, oIn, oOut)
        End Select
        If oEx.isSet Then
            If TypeName(oEx.Kind) = "cOrbSystemException" Then
                Set oSystemEx = oEx.Kind
            Else
                Set oSystemEx = New cOrbSystemException
                Call oSystemEx.setUNKNOWN(1, oSystemEx.CompletedMAYBE)
            End If
            Call exceptionLog(oEx) 'Is calling oEx.unSet()
            GoTo SendSystemEx
        End If
    Else
        If sOperation = "_non_existent" Then 'CORBA::Object pseudo-operation
            Call oOut.write_boolean(oEx, True)
            If oEx.isSet Then
                GoTo ExHandler
            End If
            repStatus = 0 'NO_EXCEPTION
        Else
            Call messageLog("Object key '" & sKey _
                & "' not found to execute '" & sOperation & "()'")
            Set oSystemEx = New cOrbSystemException
            Call oSystemEx.setINVOBJREF(1, oSystemEx.CompletedNO)
            GoTo SendSystemEx
        End If
    End If
    If responseExpected Then 'non oneway
        'send UserException?
        If repStatus <> 0 Then
            Call oOut.setPos(oEx, repStatusPos)
            If oEx.isSet Then
                GoTo ExHandler
            End If
            'ReplyStatusType reply_status;
            Call oOut.write_ulong(oEx, repStatus)
            If oEx.isSet Then
                GoTo ExHandler
            End If
        End If
    Else
        Set oOut = Nothing
    End If
    Exit Sub
SendSystemEx:
    If responseExpected Then 'non oneway
        'Init oOut again
        Call oOut.initGIOPOut(oEx, oIn.getGIOPVersion, Me)
        If oEx.isSet Then GoTo ExHandler
        'Write GIOP Reply Header
        Call writeReplyHeader(oEx, oOut, reqId, 2) '2 = SYSTEM_EXCEPTION
        If oEx.isSet Then GoTo ExHandler
        Call oSystemEx.writeMe(oEx, oOut)
        If oEx.isSet Then GoTo ExHandler
    Else
        Set oOut = Nothing
        Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
        GoTo ExHandler
    End If
    Exit Sub
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    Call oEx.addPrefix("replyRequest: ")
End Sub

'Read an object key of a request or a locate request
Private Function readReqObjKey(ByVal oEx As cOrbException, _
    ByVal oIn As cOrbStream, ByRef sKey As String) As cOrbSkeleton

    Dim baObjKey() As Byte
    If oIn.getGIOPVersion <> "1.2" Then
        'sequence <octet> object_key;
        Call oIn.readSeqOctet(oEx, baObjKey)
        If oEx.isSet Then GoTo ExHandler
    Else
        'TargetAddress target;
        Dim addrDisposition As Integer
        addrDisposition = oIn.read_short(oEx)
        If oEx.isSet Then GoTo ExHandler
        If addrDisposition <> 0 Then '0 = KeyAddr, 1 = ProfileAddr, 2 = ReferenceAddr
            '???
            Call oEx.setMe("Unknown AddressingDisposition: " & addrDisposition)
            GoTo ExHandler
        End If
        Call oIn.readSeqOctet(oEx, baObjKey)
        If oEx.isSet Then GoTo ExHandler
    End If
    sKey = objKey2String(baObjKey)
    On Error GoTo SearchErr
    Set readReqObjKey = collImpls.item(sKey)
    Exit Function
SearchErr:
    Set readReqObjKey = Nothing
    Exit Function
ExHandler:
    Call oEx.addPrefix("readReqObjKey: ")
End Function

Private Function writeReplyHeader(ByVal oEx As cOrbException, _
    ByVal oOut As cOrbStream, ByVal reqId As Long, ByVal repStatus As Long) As Long
    On Error GoTo ErrHandler
    If oOut.getGIOPVersion <> "1.2" Then
        'IOP::ServiceContextList service_context;
        Call oOut.write_ulong(oEx, 0)
        If oEx.isSet Then GoTo ExHandler
        'unsigned long request_id;
        Call oOut.write_ulong(oEx, reqId)
        If oEx.isSet Then GoTo ExHandler
        'ReplyStatusType reply_status;
        writeReplyHeader = oOut.getPos
        Call oOut.write_ulong(oEx, repStatus) '0 = NO_EXCEPTION
        If oEx.isSet Then GoTo ExHandler
    Else
        'unsigned long request_id;
        Call oOut.write_ulong(oEx, reqId)
        If oEx.isSet Then GoTo ExHandler
        'ReplyStatusType reply_status;
        writeReplyHeader = oOut.getPos
        Call oOut.write_ulong(oEx, repStatus) '0 = NO_EXCEPTION
        If oEx.isSet Then GoTo ExHandler
        'IOP::ServiceContextList service_context;
        Call oOut.write_ulong(oEx, 0)
        If oEx.isSet Then GoTo ExHandler
    End If
    Exit Function
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    Call oEx.addPrefix("writeReplyHeader: ")
End Function

'Execute a Client Locate Request (First version was written by Holger Beer)
Private Sub replyLocateRequest(ByVal oEx As cOrbException, _
    ByVal oIn As cOrbStream, ByRef oOut As cOrbStream)
    On Error GoTo ErrHandler
    'Read GIOP LocateRequest Header
    Dim reqId As Long
    'unsigned long request_id
    reqId = oIn.read_ulong(oEx)
    If oEx.isSet Then GoTo ExHandler
    'sequence <octet> object_key; or TargetAddress target;
    Dim sKey As String
    Dim oImpl As cOrbSkeleton
    Set oImpl = readReqObjKey(oEx, oIn, sKey)
    If oEx.isSet Then GoTo ExHandler
    Dim locStatus As Long
    '0 = UNKNOWN_OBJECT, 1 = OBJECT_HERE, 2 = OBJECT_FORWARD,
    '3 = OBJECT_FORWARD_PERM, 4 = LOC_SYSTEM_EXCEPTION,
    '5 = LOC_NEEDS_ADDRESSING_MODE
    locStatus = IIf(oImpl Is Nothing, 0, 1)
    'Prepare GIOP Message Header
    Call oOut.initGIOPOut(oEx, oIn.getGIOPVersion, Me)
    If oEx.isSet Then GoTo ExHandler
    'Write GIOP LocateReply Header
    Call writeLocateReplyHeader(oEx, oOut, reqId, locStatus)
    If oEx.isSet Then GoTo ExHandler
    'Do not need writing GIOP LocateReply body because locStatus is 0 or 1
    Exit Sub
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    Call oEx.addPrefix("replyLocateRequest: ")
End Sub

'(First version was written by Holger Beer)
Private Sub writeLocateReplyHeader(ByVal oEx As cOrbException, _
    ByVal oOut As cOrbStream, ByVal reqId As Long, ByVal locStatus As Long)
    On Error GoTo ErrHandler
    'unsigned long request_id;
    Call oOut.write_ulong(oEx, reqId)
    If oEx.isSet Then GoTo ExHandler
    'enum LocateStatusType;
    Call oOut.write_ulong(oEx, locStatus)
    If oEx.isSet Then GoTo ExHandler
    Exit Sub
ErrHandler:
    Call oEx.setMe(Err.Description, Err.Number)
ExHandler:
    Call oEx.addPrefix("writeLocateReplyHeader: ")
End Sub

'4.12.4, Stops the processing of requests, completing pending requests if desired
Public Sub shutdown(ByVal oEx As cOrbException, ByVal sWait As Boolean)
    If iOrbState = ORBST_ISACTIVE Then
        'Deactivate Object Adapters
        Call oServConns(0).oSock.termBind(oEx)
        If oEx.isSet Then GoTo ExHandler
        Set oServConns(0).oSock = Nothing
        iOrbState = ORBST_SHUTDOWN 'Rest must be done by perform_work() or run()
    ElseIf iOrbState = ORBST_ISINIT Then
        iOrbState = ORBST_SHUTDOWN 'Rest must be done by perform_work() or run()
    End If
    If sWait Then 'Block until the shutdown is completed?
        If bThreadUsed Then 'Blocking would result in a deadlock
            Dim oSystemEx As New cOrbSystemException
            Call oSystemEx.setBADINVORDER(3, oSystemEx.CompletedNO)
            Call oEx.setMe(oSystemEx.Description, Kind:=oSystemEx)
            GoTo ExHandler
        End If
        Call run(oEx)
        If oEx.isSet Then GoTo ExHandler
    End If
    Exit Sub
ExHandler:
    Call oEx.addPrefix("shutdown: ")
End Sub

'4.12.5, Destroys the ORB so that its resources can be reclaimed
Public Sub destroy(ByVal oEx As cOrbException)
    If iOrbState <> ORBST_ISDOWN Then
        Call shutdown(oEx, True)
        If oEx.isSet Then GoTo ExHandler
    End If
    iOrbState = ORBST_NOTEXISTS
    Exit Sub
ExHandler:
    Call oEx.addPrefix("destroy: ")
End Sub

Public Function objKey2String(ByRef objKey() As Byte) As String
    objKey2String = ""
    Dim iKey As Integer
    For iKey = LBound(objKey) To UBound(objKey)
        If objKey(iKey) <= &HF Then
            objKey2String = objKey2String & "%0" & Hex$(objKey(iKey))
        ElseIf objKey(iKey) < 32 Or objKey(iKey) >= 128 _
            Or objKey(iKey) = Asc("%") Then
            objKey2String = objKey2String & "%" & Hex$(objKey(iKey))
        Else
            objKey2String = objKey2String & Chr$(objKey(iKey))
        End If
    Next iKey
End Function
